#include "histogram.h"

vector <size_t>
make_histogram(const vector<double>& numbers, size_t & bin_count, size_t & number_count, size_t & max_count) {
    double min, max;
    find_minmax(numbers, min, max);
    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count);
    max_count = bins[0];
    for (size_t i = 0; i < number_count; i++){
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++){
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)){
                bins[j]++;
                found = true;
            }
            if (bins[j] > max_count){
                max_count = bins[j];
            }
        }
        if (!found){
            bins[bin_count - 1]++;
        }
        if (bins[bin_count - 1] > max_count){
            max_count = bins[bin_count - 1];
        }
    }
    return bins;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    if (!numbers.empty()) {
        min = numbers[0];
        max = numbers[0];
    } else {
        min = 0;
        max = 0;
    }
    for (double x : numbers)
    {
        if (x < min){
            min = x;
        }
        else if (x > max){
            max = x;
        }
    }
}
